%define section         non-free

%define origin          bea
%define priority        1310
%define javaver         1.3.1
%define buildver        05

%define name            java-%{javaver}-%{origin}
%define version         %{javaver}.%{buildver}
%define release         1jpp

%define sdklnk          java-%{javaver}-%{origin}
%define jrelnk          jre-%{javaver}-%{origin}
%define sdkdir          %{name}-%{version}
%define jredir          %{sdkdir}/jre
%define sdkbindir       %{_jvmdir}/%{sdklnk}/bin
%define jrebindir       %{_jvmdir}/%{jrelnk}/bin
%define jvmjardir       %{_jvmjardir}/%{name}-%{version}

%define x11bindir       %{_prefix}/X11R6/bin
%define x11encdir       %{_prefix}/X11R6/lib/X11/fonts/encodings
%define fontconfigdir   %{_sysconfdir}/fonts
%define fontdir         %{_datadir}/fonts/java
%define xsldir          %{_datadir}/sgml/%{name}-%{version}

# This prevents aggressive stripping on RHL 9.
%define debug_package %{nil}

# Avoid RPM 4.2+'s internal dep generator, it produces bogus Provides here.
%define _use_internal_dependency_generator 0

Name:           %{name}
Version:        %{version}
Release:        %{release}
Epoch:          0
Summary:        BEA WebLogic JRockit

Group:          Development/Interpreters
License:        BEA WebLogic JRockit Binary License
URL:            http://www.bea.com/framework.jsp?CNT=index.htm&FP=/content/products/jrockit
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        jrockit-70sp5-j2se131-linux32.tar.gz
Source1:	jrockit-8.1sp1-j2se1.4.1-LucidaTypewriterRegular.ttf
Source2:        register-%{name}-fonts.xsl
Source3:        unregister-%{name}-fonts.xsl
NoSource:       0
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      i386

Conflicts:      kaffe
BuildRequires:  jpackage-utils >= 0:1.5
Provides:       jrockit = %{epoch}:7.0-1.sp5.%{release}
Provides:       jre-%{javaver}-%{origin} = %{epoch}:%{version}, jre-%{javaver}
Provides:       jre-%{origin} = %{epoch}:%{version}, jre = %{javaver}
Provides:       java-%{javaver}, java-%{origin} = %{epoch}:%{version}
Provides:       java = %{javaver}
# TODO: verify jndi* provisions
Provides:       jndi = %{epoch}:%{version}, jndi-ldap = %{epoch}:%{version}
Provides:       jndi-cos = %{epoch}:%{version}, jndi-rmi = %{epoch}:%{version}

%description
BEA WebLogic JRockit Java Virtual Machine delivers superior
application performance, reliability, and manageability for
mission-critical Java applications running on Intel
platforms. Customers can now achieve ROI at all levels of the
infrastructure stack.
JRockit is the first and only JVM that is designed from the ground-up
specifically to address the unique requirements of server-side Java
applications.
A crucial component of the BEA WebLogic Enterprise Platform, BEA
WebLogic JRockit is highly flexible and can be customized to address
the unique performance demands of your applications.

See <http://edocs.bea.com/wljrockit/docs70/> for more information,
including info about supported platforms.

%package        devel
Summary:        BEA WebLogic JRockit SDK
Group:          Development/Compilers
Provides:       java-sdk-%{javaver}-%{origin} = %{epoch}:%{version}, java-sdk-%{javaver}
Provides:       java-sdk-%{origin} = %{epoch}:%{version}, java-sdk = %{javaver}
Provides:       java-%{javaver}-devel, java-devel-%{origin} = %{epoch}:%{version}
Provides:       java-devel = %{javaver}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{_sbindir}/update-alternatives

%description    devel
%{summary}.

%package        jdbc
Summary:        BEA WebLogic JRockit JDBC/ODBC files
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    jdbc
%{summary}.

%package        console
Summary:        BEA WebLogic JRockit management console
Group:          Development/Interpreters
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    console
%{summary}.

%package        fonts
Summary:        TrueType fonts for BEA WebLogic JRockit
Group:          Text Processing/Fonts
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{_sbindir}/chkfontpath, %{x11bindir}/mkfontdir, mktemp
Requires:       %{_bindir}/ttmkfdir, %{_bindir}/xsltproc, %{_bindir}/perl
Provides:       java-fonts = %{javaver}, java-%{javaver}-fonts
Conflicts:      java-%{javaver}-ibm-fonts, java-%{javaver}-blackdown-fonts, java-%{javaver}-sun-fonts

%description    fonts
%{summary}.


%prep


%setup -q -n jrockit70sp5_131

# Use common linux names for documentation
mkdir doc
pushd doc
mv ../License\ Agreement.txt LICENSE
mv ../console/README.txt USAGE
ln -s %{_jvmdir}/%{jredir}/lib/i386/jrockit/Xusage.txt Xusage
popd

chmod -R u+rwX,go+r-wx+X .


%build
# Nope.


%install
rm -rf $RPM_BUILD_ROOT

# main files
install -d -m 0755 $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}
cp -a bin include lib console $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}
install -d -m 0755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}
cp -a jre/bin jre/lib $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}



# extensions handling
install -d -m 0755 $RPM_BUILD_ROOT%{jvmjardir}
pushd $RPM_BUILD_ROOT%{jvmjardir}
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jndi-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jndi-ldap-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jndi-cos-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/rt.jar jndi-rmi-%{version}.jar
   for jar in *-%{version}.jar ; do
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|-%{javaver}.jar|g")
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd

# version-less symlinks
pushd $RPM_BUILD_ROOT%{_jvmdir}
ln -s %{jredir} %{jrelnk}
ln -s %{sdkdir} %{sdklnk}
popd
pushd $RPM_BUILD_ROOT%{_jvmjardir}
ln -s %{sdkdir} %{jrelnk}
ln -s %{sdkdir} %{sdklnk}
popd

# no webstart

# no man pages

# no demo

# font handling
pushd $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib

  # Remove font.properties and use the system-wide one -- NiM
  rm -f font.properties
  ln -fs %{_sysconfdir}/java/font.properties .

  # remove supplied fonts.dir in preference of the one to be dynamically
  # generated -- Rex
  rm fonts/fonts.dir

  # These %ghost'd files are created properly in %post  -- Rex
  touch fonts/{fonts.{alias,dir,scale,cache-1},XftCache,encodings.dir}

  # patch LucidaTypewriterRegular.ttf from sun-j2se1.4's working version. -- Rex
  install -m 644 %{SOURCE1} fonts/LucidaTypewriterRegular.ttf

  if [ "%{fontdir}" != "%{jredir}/lib/fonts" ] ; then
    install -d -m 0755 $RPM_BUILD_ROOT%{fontdir}
    mv fonts/* $RPM_BUILD_ROOT%{fontdir}
    rmdir fonts
    ln -sf %{fontdir} fonts
  fi

popd

# font registration/unregistration
install -d -m 0755 $RPM_BUILD_ROOT%{xsldir}
install -m 0644 %{SOURCE2} %{SOURCE3} $RPM_BUILD_ROOT%{xsldir}

# generate file lists
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type d \
  | sed "s|^$RPM_BUILD_ROOT|%dir |" >  %{name}-%{version}-all.files
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type f -o -type l \
  | grep -v Xusage.txt \
  | sed "s|^$RPM_BUILD_ROOT||"      >> %{name}-%{version}-all.files

grep    Jdbc %{name}-%{version}-all.files > %{name}-%{version}-jdbc.files
grep -v Jdbc %{name}-%{version}-all.files | \
                 grep -v jre/lib/security > %{name}-%{version}.files

find $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin -xtype f -a ! -name "console" \
  | sed "s|^$RPM_BUILD_ROOT||"      > %{name}-%{version}-sdk-bin.files


%post

  update-alternatives --install %{_bindir}/java \
    java %{jrebindir}/java %{priority} \
    --slave %{_jvmdir}/jre         jre         %{_jvmdir}/%{jrelnk} \
    --slave %{_jvmjardir}/jre      jre_exports %{_jvmjardir}/%{jrelnk} \
    --slave %{_bindir}/keytool     keytool     %{jrebindir}/keytool \
    --slave %{_bindir}/policytool  policytool  %{jrebindir}/policytool \
    --slave %{_bindir}/rmid        rmid        %{jrebindir}/rmid \
    --slave %{_bindir}/rmiregistry rmiregistry %{jrebindir}/rmiregistry \
    --slave %{_bindir}/tnameserv   tnameserv   %{jrebindir}/tnameserv

  update-alternatives --install %{_jvmdir}/jre-%{origin} \
    jre_%{origin} %{_jvmdir}/%{jrelnk} %{priority} \
    --slave %{_jvmjardir}/jre-%{origin} jre_%{origin}_exports \
      %{_jvmjardir}/%{jrelnk}

  update-alternatives --install %{_jvmdir}/jre-%{javaver} \
    jre_%{javaver} %{_jvmdir}/%{jrelnk} %{priority} \
    --slave %{_jvmjardir}/jre-%{javaver} jre_%{javaver}_exports \
      %{_jvmjardir}/%{jrelnk}

%post devel

  update-alternatives --install %{_bindir}/javac \
    javac %{sdkbindir}/javac %{priority} \
    --slave %{_jvmdir}/java         java_sdk        %{_jvmdir}/%{sdklnk} \
    --slave %{_jvmjardir}/java      java_sdk_exports %{_jvmjardir}/%{sdklnk} \
    --slave %{_bindir}/appletviewer appletviewer    %{sdkbindir}/appletviewer \
    --slave %{_bindir}/extcheck     extcheck        %{sdkbindir}/extcheck \
    --slave %{_bindir}/idlj         idlj            %{sdkbindir}/idlj \
    --slave %{_bindir}/jar          jar             %{sdkbindir}/jar \
    --slave %{_bindir}/jarsigner    jarsigner       %{sdkbindir}/jarsigner \
    --slave %{_bindir}/javadoc      javadoc         %{sdkbindir}/javadoc \
    --slave %{_bindir}/javah        javah           %{sdkbindir}/javah \
    --slave %{_bindir}/javap        javap           %{sdkbindir}/javap \
    --slave %{_bindir}/jdb          jdb             %{sdkbindir}/jdb \
    --slave %{_bindir}/native2ascii native2ascii    %{sdkbindir}/native2ascii \
    --slave %{_bindir}/rmic         rmic            %{sdkbindir}/rmic \
    --slave %{_bindir}/serialver    serialver       %{sdkbindir}/serialver \

  update-alternatives --install %{_jvmdir}/java-%{origin} \
    java_sdk_%{origin} %{_jvmdir}/%{sdklnk} %{priority} \
    --slave %{_jvmjardir}/java-%{origin} java_sdk_%{origin}_exports \
      %{_jvmjardir}/%{sdklnk}

  update-alternatives --install %{_jvmdir}/java-%{javaver} \
    java_sdk_%{javaver} %{_jvmdir}/%{sdklnk} %{priority} \
      --slave %{_jvmjardir}/java-%{javaver} java_sdk_%{javaver}_exports \
        %{_jvmjardir}/%{sdklnk}

%postun

  if [ $1 -eq 0 ]; then
    update-alternatives --remove java                %{jrebindir}/java
    update-alternatives --remove jre_%{origin}       %{_jvmdir}/%{jrelnk}
    update-alternatives --remove jre_%{javaver}      %{_jvmdir}/%{jrelnk}
  fi

%postun devel

  if [ $1 -eq 0 ]; then
    update-alternatives --remove javac               %{sdkbindir}/javac
    update-alternatives --remove java_sdk_%{origin}  %{_jvmdir}/%{sdklnk}
    update-alternatives --remove java_sdk_%{javaver} %{_jvmdir}/%{sdklnk}
  fi

# We do not care if all/any of this actually succeeds
# Therefore errors are catched but messages allowed
%post fonts
{
  # Legacy font handling
  %{_bindir}/ttmkfdir -d %{fontdir} -o %{fontdir}/fonts.scale

  # Mandrake workaround
  %{_bindir}/perl -pi -e 's@0-c-0@0-p-0@g' %{fontdir}/fonts.scale

  %{x11bindir}/mkfontdir -e %{x11encdir} -e %{x11encdir}/large %{fontdir}

  %{_sbindir}/chkfontpath -q -a %{fontdir}

  # The following commands will be executed on upgrade by their respective
  # packages

  # Late legacy font handling
  if [ -x %{_bindir}/redhat-update-gnome-font-install ] ; then
      %{_bindir}/redhat-update-gnome-font-install
  fi
  if [ -x %{_bindir}/redhat-update-gnome-font-install2 ] ; then
      %{_bindir}/redhat-update-gnome-font-install2
  fi

  # Modern font handling
  if [ -x %{_bindir}/fc-cache ] ; then
    %{_bindir}/fc-cache -f %{_datadir}/fonts
  fi
} || :

%preun fonts

  if [ $1 -eq 0 ] ; then
    # Unregister self in fontconfig aliases
    if [ -w %{fontconfigdir}/fonts.conf ] ; then
      TMPFILE=$(mktemp -q /tmp/fonts.conf.XXXXXX) && \
      %{_bindir}/xsltproc --novalid %{xsldir}/unregister-%{name}-fonts.xsl \
        %{fontconfigdir}/fonts.conf > $TMPFILE && \
      cat $TMPFILE > %{fontconfigdir}/fonts.conf && rm $TMPFILE
    fi
  fi

# We do not care if all/any of this actually succeeds
# Therefore errors are catched but messages allowed
%postun fonts
{
  # Rehash the font dir to keep only stuff manually installed
  [ $1 -eq 0 ] || exit 0

  if [ -d %{fontdir} ] && [ $(%{_bindir}/find %{fontdir} \
        -follow -type f -iname "*.ttf" -printf "\b\b\b\btrue") ] ; then
    %{_bindir}/ttmkfdir -d %{fontdir} -o %{fontdir}/fonts.scale
    %{x11bindir}/mkfontdir -e %{x11encdir} -e %{x11encdir}/large %{fontdir}
  else
    %{_sbindir}/chkfontpath -q -r %{fontdir}
  fi

  if [ -x %{_bindir}/redhat-update-gnome-font-install ] ; then
    %{_bindir}/redhat-update-gnome-font-install
  fi
  if [ -x %{_bindir}/redhat-update-gnome-font-install2 ] ; then
    %{_bindir}/redhat-update-gnome-font-install2
  fi

  if [ -x %{_bindir}/fc-cache ] ; then
    %{_bindir}/fc-cache -f %{_datadir}/fonts
  fi
} || :

%triggerin fonts -- fontconfig, %{fontconfigdir}/fonts.conf

  TMPFILE=$(mktemp -q /tmp/fonts.conf.XXXXXX) && \
  %{_bindir}/xsltproc --novalid %{xsldir}/register-%{name}-fonts.xsl \
    %{fontconfigdir}/fonts.conf > $TMPFILE && \
  cat $TMPFILE > %{fontconfigdir}/fonts.conf && rm $TMPFILE


%clean
rm -rf $RPM_BUILD_ROOT


%files -f %{name}-%{version}.files
%defattr(-,root,root,-)
%doc doc/LICENSE doc/Xusage
%dir %{_jvmdir}/%{sdkdir}
%dir %{jvmjardir}
%{jvmjardir}/*.jar
%{_jvmdir}/%{jrelnk}
%{_jvmjardir}/%{jrelnk}
%dir %{_jvmdir}/%{jredir}/lib/security
%doc %{_jvmdir}/%{jredir}/lib/i386/jrockit/Xusage.txt
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/cacerts
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/java.policy
%config(noreplace) %{_jvmdir}/%{jredir}/lib/security/java.security

%files devel -f %{name}-%{version}-sdk-bin.files
%defattr(-,root,root,-)
%dir %{_jvmdir}/%{sdkdir}/bin
%{_jvmdir}/%{sdkdir}/include
%{_jvmdir}/%{sdkdir}/lib
%{_jvmdir}/%{sdklnk}
%{_jvmjardir}/%{sdklnk}

%files console
%defattr(-,root,root,-)
%doc doc/USAGE
%{_jvmdir}/%{sdkdir}/bin/console
%{_jvmdir}/%{sdkdir}/bin/i386/native_threads/console
%dir %{_jvmdir}/%{sdkdir}/console
%{_jvmdir}/%{sdkdir}/console/lib
%{_jvmdir}/%{sdkdir}/console/*.jar

%files jdbc -f %{name}-%{version}-jdbc.files
%defattr(-,root,root,-)

%files fonts
%defattr(0644,root,root,0755)
%dir %{fontdir}
%dir %{xsldir}
%{fontdir}/*.ttf
%{xsldir}/*.xsl
%config(noreplace) %{fontdir}/fonts.alias
%ghost %{fontdir}/fonts.dir
%ghost %{fontdir}/fonts.scale
%ghost %{fontdir}/fonts.cache-1
%ghost %{fontdir}/XftCache
%ghost %{fontdir}/encodings.dir


%changelog
* Wed Jun 16 2004 Nicolas Mailhot <Nicolas.Mailhot at laPoste.net> - 0:1.3.1.05-1jpp
- update to SP5

* Mon Oct 28 2003 Nicolas Mailhot <Nicolas.Mailhot at laPoste.net> - 0:1.3.1.04-2jpp
- fix -X

* Mon Oct 27 2003 Nicolas Mailhot <Nicolas.Mailhot at laPoste.net> - 0:1.3.1.04-1jpp
- initial "sure it's working" release, derived from Ville's 0:1.4.1.03-2jpp and others
- still some empty dangling dirs to sort out on uninstall
